{\rtf0\ansi{\fonttbl\f0\fmodern Courier;\f2\ftech Symbol;\f1\fmodern Ohlfs;}
\margl40
\margr40
\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx5320\f0\b0\i0\ulnone\fs24\fc0\cf0 //\
//
\i 	
\b FILENAME
\b0 :	
\b\i0 eTDoc.h \

\b0 //
\i 	
\b SUMMARY
\b0 :	
\b\i0 Interface for the abstract document controller.
\b0 \
//	
\b\i SUPERCLASS
\b0 :
\i0 	
\b Object:eTDoc
\b0 \
//	
\b\i PROTOCOLS
\b0 :
\i0 	
\b Uses <DocNotification>
\b0 \
//	
\b\i INTERFACE
\b0 :
\i0 	
\b None
\b0 \
//	
\b\i AUTHOR
\b0 :		
\b\i0 Rohit Khare
\b0 \
//	
\b\i COPYRIGHT
\b0 :	
\f2\i0 
\f0\b 1993,94 California Institure of Technology, eText Project\

\b0 //\
//	
\b\i Description
\b0\i0 \
//		This is the document-model, and thus encapsulates the true state and\
//	fundamental behaviors of an etf document. It coordinates with 
\i etDocUI
\i0  to\
//	actually offer user access to these features.\
//		If someone will explain how, 
\i etDoc
\i0  should have an 
\i NXDataLinkManager
\i0 \
//\
//	
\b\i HISTORY
\b0\i0 \
//	10/06/94:	
\b Revamped for eText5.
\i \

\b0\i0 //	08/05/94:	
\b Added undoManager. RK
\b0 \
//	01/14/94:	
\b Revised extensively for eText4
\b0 \
//	09/11/93:	
\b Created (un)registerForDocNotification. <DocNotification>
\b0 \
//	09/09/93:	
\b Added support for the docID member.
\b0 \
//	08/22/93:	
\b Moved "Accessor Methods" to eTDoc
\b0 \
//	08/20/93:	
\b Created.
\b0 \
//\
//	
\b Imported Interfaces
\b0 \
//\
	#import	"
\b eTextKernel.h
\b0 "\
	#import	"
\b UndoManager.h
\b0 "\
	@class 
\b eTDocUI, eTDocInfo
\b0 ;\
\
//\
//	
\b Garbage Collection (C code)
\b0 \
//\
	extern int 
\b removeFile
\b0 (const char *
\b file
\b0 );\
\

\i @interface eTDoc:Object
\i0  \{\
//\
//	
\b Instance Variables
\b0 \
//\
	
\b eTDocInfo
\b0 	*
\b theDocInfo
\b0 ;\
	
\b eTDocUI
\b0 		*
\b docUI
\b0 ;\
	
\b List
\b0 		*
\b notificationList
\b0 ;\
	
\b HashTable
\b0 	*
\b componentTable
\b0 ;\
	
\b UndoManager
\b0 	*
\b undoManager
\b0 ;\
	
\b id
\b0 			
\b selectedObj
\b0 ;\
	
\b id
\b0 			
\b theAgent
\b0 ;\
	\}\
\
//\
// 	
\b Class Management
\b0 \
//\
	- 
\b initForDocInfo
\b0 :(
\b eTDocInfo
\b0  *) newDocInfo;\
	- 
\b free
\b0 ;\
\
//\
// 	
\b Document Management (by path)
\b0 \
//\
	- 
\b openFrom
\b0 :(const char *)thePath;\
	- 
\b saveTo
\b0 :(const char*)thePath 
\b inFormat
\b0 :(
\b int
\b0 )fmt 
\b changePath
\b0 :(
\b BOOL
\b0 ) changeIt;\
	- 
\b close
\b0 :sender 
\b allowCancel
\b0 :(
\b BOOL
\b0 )cancellable;\
	- 
\b save
\b0 :sender;\
	\
	- 
\b saveASCII
\b0 :(const char *)thePath;\
	- 
\b saveC
\b0 :(const char *)thePath;\
	- 
\b saveRTF
\b0 :(const char *)thePath;\
	- 
\b saveLaTeX
\b0 :(const char *)thePath;\
	- 
\b saveHTMD
\b0 :(const char *)thePath;\
	- 
\b saveETFD
\b0 :(const char *)thePath 
\b changePath
\b0 :(
\b BOOL
\b0 ) changeIt;\
\
//\
// 	
\b <DocNotification> Registration & Callbacks
\b0 \
//\
	- 
\b registerNotification
\b0 :theListener;\
	- 
\b unregisterNotification
\b0 :theListener;\
	- 
\b registerComponent
\b0 :(
\b NXAtom
\b0 )component;\
\
//\
// 	
\b Accessors & API
\b0 \
//\
	- (UndoManager *)
\b undoManager
\b0 ;\
	- (eTDocInfo *)
\b docInfo
\b0 ;\
	- (eTDocUI *)
\b docUI
\b0 ; // 
\i Private
\i0 \
	\
	- 
\b touch
\b0 ;\
	- (
\b BOOL
\b0 ) 
\b needsSaving
\b0 ;\
	\
	- (
\b BOOL
\b0 ) 
\b acceptsAnnotation
\b0 ;\
	- 
\b insertAnnotation
\b0 :theAnnotation;\
	\
	- (
\b BOOL
\b0 ) 
\b acceptsAgent
\b0 ;\
	- 
\b attachAgent
\b0 :newAgent;\
	- 
\b detachAgent
\b0 ;\
\
	- 
\b selectedObj
\b0 ;\
	- 
\b setSelectedObj
\b0 :it;\
	- 
\b makeVisible
\b0 ;\
	- 
\b inspect
\b0 ;\
\
@end
}
